# Prune at the Clients, Not the Server:Accelerated Sparse Training in Federated Learning

This is the official implementation of the paper Sparse-Proxskip, ICLR 2025 Review Only. All rights reserved by the No. 400 Submission Authors.

## Environment Setup
```bash
pip install -r requirements.txt
```

## Reproduce Core Results of Sparse ProxSkip
For the three type of experiments are three scripts:
- `regression_exp.py` for multiple linear regression
- `LogR_exp.py` for multiple logistic regression
- `dnn_exp.py` for the deep learning experiments.

All of them can be run from the command line with
`python FILE -t TARGET_SPARSITY`
With command line options the desired configuration can be run. 
Run 
`python FILE --help` 
to see all available options for customising the script.

## Datasets
- CIFAR10 will be automatically downloaded
- Blog Feedback dataset can be downloaded and preprocessed by inspecting `BlogFeedback_Regression.ipynb`
- FEMNIST can be installed via leaf (citation in paper)
